// MntDlg.cpp
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <Shellapi.h>
#include <Shlwapi.h>

// C RunTime Header Files
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>

#include "filedisk.h"
#include "fd_tools.h"
#include "resource.h"

#ifndef WINIMAGE_EXE
#include "minitray.h"
int LoadInternatString(UINT uID,LPTSTR lpBuffer,int nBufferMax)
{
    return LoadString(ghRes,uID,lpBuffer,nBufferMax);
}

LONG_PTR MyGetWindowLongPtr(HWND hWnd,int nIndex)
{
    return GetWindowLongPtr(hWnd,nIndex);
}

LONG_PTR MySetWindowLongPtr(HWND hWnd,int nIndex, LONG_PTR dwNewLong)
{
    return SetWindowLongPtr(hWnd, nIndex, dwNewLong) ;
}

HINSTANCE GetLingResHinst()
{
    return ghRes;
}

WORD GetVersionReordered()
{
  WORD wVer = LOWORD(GetVersion());
  return (((WORD)LOBYTE(wVer)) << 8) | (WORD)HIBYTE(wVer);
}

BOOL IsWin95OrGreatherLook()
{
  //return FALSE; // only for tired old CommDlg
  return (GetVersionReordered() >= 0x035F);
}

BOOL GetWin32ErrorMessage(DWORD dwErr, LPTSTR lpBuffer, DWORD nSize,BOOL fAppend)
{
    DWORD dwRetFmt;
    if (fAppend)
    {
        DWORD dwLen = lstrlen(lpBuffer);
        if (dwLen>=nSize)
            return FALSE;
        nSize -= dwLen;
        lpBuffer += dwLen;
    }
    dwRetFmt= (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM ,NULL,dwErr,0,
                      lpBuffer,nSize,
                      NULL) );
    return (dwRetFmt!=0);
}
int WinLongRawSzToStr(LPTSTR szRawNumber, LPTSTR lpszStr, int cbStr)
{
    TCHAR szFormattedNumber[MAX_PATH+1+0x10];
    TCHAR szDecimalSep[0x11];
    LPTSTR lpLastDecimalSeparator=NULL;
    LPTSTR lpszBrowseFormatted;
    UINT uiszDecimalSepLenInByte;

    GetNumberFormat(LOCALE_USER_DEFAULT,0,szRawNumber,NULL,szFormattedNumber,MAX_PATH);
    GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SDECIMAL,szDecimalSep, 0x10);
    uiszDecimalSepLenInByte = lstrlen(szDecimalSep)*sizeof(TCHAR);

    lpszBrowseFormatted = szFormattedNumber;
    while ((*lpszBrowseFormatted) != 0)
    {
        if (memcmp(szDecimalSep,lpszBrowseFormatted,uiszDecimalSepLenInByte)==0)
            lpLastDecimalSeparator = lpszBrowseFormatted;
        lpszBrowseFormatted = CharNext(lpszBrowseFormatted);
    }
    if (lpLastDecimalSeparator!=NULL)
        *lpLastDecimalSeparator=0;

    if (lstrlen(szFormattedNumber)>=cbStr)
        return 0;
    lstrcpy(lpszStr,szFormattedNumber);
    return lstrlen(lpszStr);
}


int WinLongToStr(long lNum, LPTSTR lpszStr, int cbStr)
{
    TCHAR szRawNumber[MAX_PATH];
    wsprintf(szRawNumber,"%lu",lNum);
    return WinLongRawSzToStr(szRawNumber,lpszStr,cbStr);
}
#else
#include <commdlg.h>
#include <shellapi.h>
#include "miscutil.h"
#include "HFileCpt.h"
#include "winimage.h"
#include "resource.h"
#include "statetoo.h"
#include "usrfile.h"
#include "miscwima.h"
#include "disk.h"
#include "WimaCDlg.h"
#endif

#include "MntDlg.h"

int MessageWin32Error(HWND hWnd,DWORD dwErr,UINT uiTxtTitle,UINT uType)
{
    int iRes;
    TCHAR szErrorText[MAX_PATH+0x8];
    TCHAR szTitle[MAX_PATH+0x08];
    szTitle[0]=szErrorText[0]=0;

    FormatMessage(         
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dwErr,
        0,
        (LPTSTR) szErrorText,
        MAX_PATH,
        NULL
        );

    if (uiTxtTitle != 0)
        LoadInternatString(uiTxtTitle,szTitle,MAX_PATH);
    iRes=MessageBox(hWnd,szErrorText,(uiTxtTitle != 0) ? szTitle : 0,uType);
    return iRes;
}


BOOL GetDisplayableFileName(LPCWSTR lpszDDkName,LPTSTR lpszFileNameDisplay,DWORD dwSize)
{
    int iPos=0;
    int iPosWr=0;
    if (((*(lpszDDkName+0))=='\\') &&
        ((*(lpszDDkName+1))=='?') &&
        ((*(lpszDDkName+2))=='?') &&
        ((*(lpszDDkName+3))=='\\'))
    {
        iPos=4;
        if (((*(lpszDDkName+4))=='U') &&
            ((*(lpszDDkName+5))=='N') &&
            ((*(lpszDDkName+6))=='C') &&
            ((*(lpszDDkName+7))=='\\'))
        {
            iPos+=3;
            iPosWr=1;
            *lpszFileNameDisplay='\\';
        }
    }
    
    wsprintf(lpszFileNameDisplay+iPosWr,"%ws",lpszDDkName+iPos);
    return TRUE;
}

#define IDS_LISTVIEW_MOUNTIMAGE_LASTTITLECOLUMN IDS_LISTVIEW_MOUNTIMAGE_TITLECOLUMN4
#define LISTVIEW_MOUNTIMAGE_NBCOLUMN (1 + IDS_LISTVIEW_MOUNTIMAGE_LASTTITLECOLUMN - IDS_LISTVIEW_MOUNTIMAGE_TITLECOLUMN1)

void DisableEnableMountButton(HWND hDlg)
{
    BOOL fEnable;
    fEnable = ListView_GetSelectedCount(GetDlgItem(hDlg,IDC_LISTMOUNTEDFILEDISK))>0;
    EnableWindow(GetDlgItem(hDlg,IDC_FILEDISK_UNMOUNT),fEnable);
}

BOOL ListView_Mount_Configure(HWND hDlg,BOOL fCreateColumn,HWND hWndLV)
{
    UINT i;
    int iItemNbr=0;
    ListView_DeleteAllItems(hWndLV);

    if (fCreateColumn)
    {
        for (i=0;i<LISTVIEW_MOUNTIMAGE_NBCOLUMN;i++)
        ListView_DeleteColumn(hWndLV,i);


        for (i=0;i<LISTVIEW_MOUNTIMAGE_NBCOLUMN;i++)
        {
            LV_COLUMN lvC;
            TCHAR szTitle[MAX_PATH+2];
            LoadInternatString(IDS_LISTVIEW_MOUNTIMAGE_TITLECOLUMN1+i,szTitle,MAX_PATH);

            lvC.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
            lvC.fmt = /*((i==3) || (i==6)) ? LVCFMT_RIGHT :*/ LVCFMT_LEFT;
            lvC.cx =70;            // width of column in pixels
            if (i==0)
                lvC.cx =27;
            if (i==1)
                lvC.cx =205;
            if (i==3)
                lvC.cx = 64;
            if (i==4)
                lvC.cx = 68;
            lvC.cx +=10;
            lvC.pszText = szTitle;
            ListView_InsertColumn(hWndLV, i, &lvC);
        }
    }
    
    for (i=0;i<26;i++)
    {
        MOUNT_INFORMATION mi;
        if (GetMountInfo(i,&mi))
        {
                LV_ITEM lvItem;
                TCHAR szText[MAX_PATH+2]="";
                int j;
                memset(&lvItem,0,sizeof(lvItem));
                lvItem.mask=/*LVIF_TEXT|*/LVIF_STATE|LVIF_PARAM;
                lvItem.stateMask=LVIS_SELECTED ;
                lvItem.state= /*(i==0) ? LVIS_SELECTED :*/0;
                lvItem.lParam=i;
                lvItem.pszText=szText; 
                lvItem.iItem=iItemNbr;
                iItemNbr++;
                int iItem=ListView_InsertItem(hWndLV,&lvItem);

                for (j=0;j<LISTVIEW_MOUNTIMAGE_NBCOLUMN;j++)
                {
                    TCHAR szText[MAX_PATH+2]="";
                    UINT uiRes=0;
                    wsprintf(szText,"%u",j);

                    if (j==0)
                        wsprintf(szText,"%c:",i+'a');

                    if (j==1)
                    {
                        int iPos=0;
                        if ((mi.FileNameMount[0]=='\\') &&
                            (mi.FileNameMount[1]=='?') &&
                            (mi.FileNameMount[2]=='?') &&
                            (mi.FileNameMount[3]=='\\'))
                            iPos=4;
                        //else

                        GetDisplayableFileName(mi.FileNameMount,szText,MAX_PATH);
                    }

                    if (j==2) //  bootIndicator; : 0x00:    0x88=Bootable, 0x00 not Bootable
                    {
                        if (mi.fReadOnly)
                            uiRes=IDS_MOUNTINFO_RO_YES;
                        else
                            uiRes=IDS_MOUNTINFO_RO_NO;
                    }

                    if (j==3) // segment
                    {
                        TCHAR szFmt[MAX_PATH+2];
                        TCHAR szSize[MAX_PATH+2];
                        LONG lSizeKB;
                        LoadInternatString(IDS_SIZEIMAGEKB,szFmt,MAX_PATH);        
#ifndef WINIMAGE_EXE
                        lSizeKB=(LONG)(mi.SizeMountedData.QuadPart/1024);
#else
                        lSizeKB = (LONG)GetKBSizeFrom64Size(mi.SizeMountedData.LowPart,mi.SizeMountedData.HighPart);
#endif
                        WinLongToStr(lSizeKB,szSize,MAX_PATH);
                        wsprintf(szText,szFmt,szSize);
                    }
                    if (uiRes!=0)
                        LoadInternatString(uiRes,szText,MAX_PATH);
                    ListView_SetItemText(hWndLV,iItem,j,szText);
                }
        }
    }

    DisableEnableMountButton(hDlg);

    return TRUE;
}



class DLGPROCANDPARAM
{
public:
    DLGPROCANDPARAM() {};
    virtual ~DLGPROCANDPARAM() {} ;
    virtual BOOL DlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
               { return FALSE; } ;
} ;

static LONG CALLBACK CBDlgProcAndParamDlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
    DLGPROCANDPARAM* pDlgProcAndParam;
    if (message==WM_INITDIALOG)
        MySetWindowLongPtr(hDlg,DWLP_USER,lParam);

    pDlgProcAndParam=(DLGPROCANDPARAM*)MyGetWindowLongPtr(hDlg,DWLP_USER);

    if (pDlgProcAndParam != NULL)
      return pDlgProcAndParam->DlgProc(hDlg,message,wParam,lParam);
    else
      return 0;
}

typedef struct
{
    BOOL fUnMountDone;
} DLGMOUNTLISTPARAM;

class DLGMOUNTLISTPROCANDPARAM:public DLGPROCANDPARAM
{
public:
    DLGMOUNTLISTPROCANDPARAM(DLGMOUNTLISTPARAM* pDlgParamSet)
      { pDlgParam = pDlgParamSet; } ;

    ~DLGMOUNTLISTPROCANDPARAM() { };
    BOOL DlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam);
private:
    DLGMOUNTLISTPARAM* pDlgParam;
} ;



BOOL DLGMOUNTLISTPROCANDPARAM::DlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
    switch(message)
    {
    case WM_INITDIALOG:
        ListView_Mount_Configure(hDlg,TRUE,GetDlgItem(hDlg,IDC_LISTMOUNTEDFILEDISK));
        CheckDlgButton(hDlg,IDC_FILEDISK_LIMITSIZE_RADIO_KBYTES,BST_CHECKED);
        break;

     case WM_NOTIFY:
         {
             if ((wParam==IDC_LISTMOUNTEDFILEDISK) && ((((LPNMHDR) lParam)->code)==LVN_ITEMCHANGED))
                 DisableEnableMountButton(hDlg);
         }
         break;

     case WM_COMMAND:
           {
               WORD wId = GET_WM_COMMAND_ID(wParam,lParam);

               if (wId == IDC_GETHELP)
               {

#ifdef WINIMAGE_EXE
                   WinHelpApp(GetParent(hDlg),HELP_CONTEXT,HELPID_MOUNTIMAGE,"::/mountimage.html");
#endif

                   /*
                   DoHelpContents(hDlg,//*pADDCONTENTDFSDLGParam->pGuiItem,
                                  "::/Ordering_SmartVersion.htm");
                                  */
                   return TRUE;
               }
/*
               if (wId == IDC_LISTMOUNTEDFILEDISK)
                   DisableEnableMountButton(hDlg);
*/
               if (wId == IDC_FILEDISK_UNMOUNT)
               {
                   HWND hWndLV =GetDlgItem(hDlg,IDC_LISTMOUNTEDFILEDISK);
                   DWORD dwCount = ListView_GetItemCount (hWndLV);
                   DWORD i;
                   DWORD dwFocusItem=0;
                   char cDrive;
                    
                   for (i=0;i<dwCount;i++)
                   {
                        if (ListView_GetItemState(hWndLV,i,LVIS_FOCUSED)!=0)
                        {
                            LV_ITEM lvI;
                            dwFocusItem=i;
                            memset(&lvI,0,sizeof(LV_ITEM));

                            lvI.iItem    = i;
                            lvI.iSubItem = 0;
                            lvI.mask     = LVIF_PARAM;

                            ListView_GetItem(hWndLV, &lvI);
                            cDrive=(char)lvI.lParam;
                            
                            break;
                        }
                   }

                   if (i<dwCount)
                   {
                       DWORD dwErr=0;
                       if (!(FileDiskUmount(cDrive,dwErr)))
                           MessageWin32Error(hDlg,dwErr,0,MB_OK|MB_ICONERROR);
                       else
                           pDlgParam->fUnMountDone=TRUE;
                       ListView_Mount_Configure(hDlg,FALSE,hWndLV);
                   }
                   break;
               }

               if (wId == IDOK)
               {
               }

               if ((wId == IDOK) || (wId == IDCANCEL))
               {
                   EndDialog(hDlg, (wId == IDOK));
                   return (TRUE);
               }
           }
           break;

    }
    return FALSE;    
}

BOOL DoDialogMountList(HWND hWnd,LPBOOL lpfUnMoundDone)
{
    BOOL fRet;
    DLGMOUNTLISTPARAM DlgParam;
    DLGMOUNTLISTPROCANDPARAM DlgRegisterProcAndParam(&DlgParam);
    DlgParam.fUnMountDone=FALSE;
    fRet = (BOOL)DialogBoxParam(GetLingResHinst(),
                                "IDD_MOUNTEDIMAGE",//MAKEINTRESOURCE(IDD_MOUNTEDIMAGE), 
                                hWnd,
                                (DLGPROC)CBDlgProcAndParamDlgProc,
                                (LPARAM)(&DlgRegisterProcAndParam));
    if (lpfUnMoundDone!=NULL)
    {
        *lpfUnMoundDone = DlgParam.fUnMountDone;
    }
    return fRet;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------


typedef struct
{
    MOUNT_REQUEST_USER mru;
    char cDriveLetter;
} DLGMOUNTNEWIMAGEPARAM;

class DLGMOUNTNEWIMAGEPROCANDPARAM:public DLGPROCANDPARAM
{
public:
    DLGMOUNTNEWIMAGEPROCANDPARAM(DLGMOUNTNEWIMAGEPARAM* pDlgParamSet)
      { pDlgParam = pDlgParamSet; } ;

    ~DLGMOUNTNEWIMAGEPROCANDPARAM() { };
    BOOL DlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam);
private:
    DLGMOUNTNEWIMAGEPARAM* pDlgParam;
} ;



static void ConvertFilterToSepNull(LPTSTR pFilter)
{
   TCHAR c;
   while ((c=(*pFilter)) != '\0')
     {
       LPTSTR pNextFilter = CharNext (pFilter);
       if (c == '|') *pFilter = '\0';
       pFilter = pNextFilter ;
     }
   *(pFilter) = '\0';
   *(pFilter+1) = '\0';
}


static void LoadFilter(WORD wId,PSTR pFilter,int sz)
{
   LoadInternatString(wId,pFilter,sz-4);
   lstrcat(pFilter,"||");
   ConvertFilterToSepNull(pFilter);
}


static void InitOpenFileName(OPENFILENAME * pofn,HWND hWnd,
                    WORD wIdFilter,PSTR pFilter,int szFilter,
                    LPSTR lpstrFile,DWORD dwSizeFile,
                    LPSTR lpCapt,WORD wIdCapt,int szCapt)
{
WORD wVer;
BOOL fSupportNewOpenFileName;
   wVer = LOWORD(GetVersion());
   wVer = (((WORD)LOBYTE(wVer)) << 8) | (WORD)HIBYTE(wVer);

   fSupportNewOpenFileName= (wVer>=0x45a);
   memset(pofn, 0, sizeof(OPENFILENAME));

   LoadFilter(wIdFilter,pFilter,szFilter);

   pofn->lStructSize = sizeof(OPENFILENAME);

   pofn->hwndOwner = hWnd;
   pofn->lpstrFilter = pFilter ;
   pofn->nFilterIndex = 1;
   pofn->lpstrFile = lpstrFile;
   pofn->nMaxFile = dwSizeFile;

   if (wIdCapt != 0)
     {
       LoadInternatString(wIdCapt,lpCapt,szCapt);
       pofn->lpstrTitle = lpCapt;
     }

   pofn->Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST /*| OFN_HIDEREADONLY*/;
}

BOOL InitListOfDrive(HWND hwndCombo)
{
    DWORD i;
    BOOL fFirst=TRUE;
    ComboBox_ResetContent(hwndCombo);
    for (i=0;i<26;i++)
        if (!IsDriveAssigned(i))
    {
        TCHAR szDrive[10] ;
        int iIndex;
        wsprintf(szDrive,"%c:",i+'a');
        iIndex = ComboBox_AddString(hwndCombo,(LPSTR)szDrive);
        ComboBox_SetItemData(hwndCombo,iIndex,i);
        if (fFirst)
           ComboBox_SetCurSel(hwndCombo, iIndex);

        fFirst=FALSE;
    }
    return TRUE;
}

BOOL InitListOfType(HWND hwndComboType)
{
    DWORD i;
    DWORD iPos;
    ComboBox_ResetContent(hwndComboType);
    for (i=IDS_MOUNTTYPEFILE_ISO,iPos=0;i<=IDS_MOUNTTYPEFILE_DISK;i++,iPos++)
    {
        TCHAR szTypeText[MAX_PATH+0x8] ;
        int iIndex;
        szTypeText[0]=0;
        LoadInternatString(i,szTypeText,MAX_PATH);
        iIndex = ComboBox_AddString(hwndComboType,(LPSTR)szTypeText);
        ComboBox_SetItemData(hwndComboType,iIndex,iPos);
        if (iPos==0)
           ComboBox_SetCurSel(hwndComboType, iIndex);
    }
    return TRUE;
}

void InitLimitSizeCtlFromCheck(HWND hDlg)
{
    BOOL fChecked=IsDlgButtonChecked(hDlg,IDC_FILEDISK_CHECKLIMITSIZE) == BST_CHECKED;
    EnableWindow(GetDlgItem(hDlg,IDC_FILEDISK_EDITLIMITSIZE),fChecked);
    EnableWindow(GetDlgItem(hDlg,IDC_FILEDISK_LIMITSIZE_RADIO_KBYTES),fChecked);
    EnableWindow(GetDlgItem(hDlg,IDC_FILEDISK_LIMITSIZE_RADIO_MBYTES),fChecked);
    EnableWindow(GetDlgItem(hDlg,IDC_FILEDISK_LIMITSIZE_RADIO_GBYTES),fChecked);
}

BOOL DLGMOUNTNEWIMAGEPROCANDPARAM::DlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
    switch(message)
    {
    case WM_INITDIALOG:
        InitListOfDrive(GetDlgItem(hDlg,IDC_FILEDISK_COMBODRIVELETTER));
        InitListOfType(GetDlgItem(hDlg,IDC_FILEDISK_COMBOFILETYPE));
        InitLimitSizeCtlFromCheck(hDlg);
        pDlgParam->mru.fReadOnly=FALSE;
        EnableWindow(GetDlgItem(hDlg,IDC_FILEDISK_READONLY),pDlgParam->mru.MountType==MOUNT_TYPE_DISKIMAGE);
        CheckDlgButton(hDlg,IDC_FILEDISK_READONLY,BST_CHECKED);
        break;

     case WM_COMMAND:
           {
               WORD wId = GET_WM_COMMAND_ID(wParam,lParam);
               HWND hCtlComboFileType=GetDlgItem(hDlg,IDC_FILEDISK_COMBOFILETYPE);
               HWND hCtlComboDrive = GetDlgItem(hDlg,IDC_FILEDISK_COMBODRIVELETTER);



               if (wId == IDC_GETHELP)
               {

#ifdef WINIMAGE_EXE
                   WinHelpApp(GetParent(hDlg),HELP_CONTEXT,HELPID_MOUNTIMAGE,"::/mountimage.html");
#endif

                   /*
                   DoHelpContents(hDlg,//*pADDCONTENTDFSDLGParam->pGuiItem,
                                  "::/Ordering_SmartVersion.htm");
                                  */
                   return TRUE;
               }

               if (wId == IDC_FILEDISK_CHECKLIMITSIZE)
                   InitLimitSizeCtlFromCheck(hDlg);

               if (wId == IDC_FILEDISK_FILENAMEMOUNT_BROWSE)
               {
                   OPENFILENAME ofn;
                   memset(&ofn,0,sizeof(OPENFILENAME));
                   TCHAR szFilter[MAX_PATH+0x8];
                   TCHAR szFile[MAX_PATH+0x8];
                   szFile[0]=szFilter[0]=0;
                   
                   InitOpenFileName(&ofn,hDlg,IDS_TYPEIMAGE,szFilter,MAX_PATH,
                                        szFile,MAX_PATH,NULL,0,0);

                   ofn.nFilterIndex = 1+(DWORD)ComboBox_GetItemData(hCtlComboFileType,ComboBox_GetCurSel(hCtlComboFileType));


                   ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY |
                            OFN_OVERWRITEPROMPT ;
                   #ifdef WIN32
                   if (IsWin95OrGreatherLook())
                       ofn.Flags |= OFN_EXPLORER | OFN_ENABLESIZING;
                   #endif
                   ofn.lpstrFile=szFile;
                   GetDlgItemText(hDlg,IDC_FILEDISK_FILENAMEMOUNT,szFile,MAX_PATH);
                   if (GetOpenFileName(&ofn))
                   {
                       SetDlgItemText(hDlg,IDC_FILEDISK_FILENAMEMOUNT,ofn.lpstrFile);
                       ComboBox_SetCurSel(hCtlComboFileType,ofn.nFilterIndex-1);
                   }
               }

               if (wId == IDC_FILEDISK_COMBOFILETYPE)
               {
                   int iPosType;
                   iPosType=(int)ComboBox_GetItemData(hCtlComboFileType,ComboBox_GetCurSel(hCtlComboFileType));
                   MOUNT_TYPE mntOld = pDlgParam->mru.MountType;
                   switch (iPosType)
                   {
                   case 0 :
                       pDlgParam->mru.MountType = MOUNT_TYPE_ISO;
                       break;

                   case 1 :
                       pDlgParam->mru.MountType = MOUNT_TYPE_BIN;
                       break;
                   case 2 :
                       pDlgParam->mru.MountType = MOUNT_TYPE_DISKIMAGE;
                       break;
                   }

                   if (mntOld != pDlgParam->mru.MountType)
                   {
                       BOOL fCtlROEnabled = pDlgParam->mru.MountType==MOUNT_TYPE_DISKIMAGE;
                       if (IsWindowEnabled(GetDlgItem(hDlg,IDC_FILEDISK_READONLY)))
                         pDlgParam->mru.fReadOnly = IsDlgButtonChecked(hDlg,IDC_FILEDISK_READONLY) == BST_CHECKED;
                       EnableWindow(GetDlgItem(hDlg,IDC_FILEDISK_READONLY),fCtlROEnabled);
                       CheckDlgButton(hDlg,IDC_FILEDISK_READONLY,
                           ((fCtlROEnabled && pDlgParam->mru.fReadOnly) || (!fCtlROEnabled)) ? BST_CHECKED : BST_UNCHECKED);
                   }
                       
                   break;
               }

               if (wId == IDOK)
               {
                   TCHAR szFileName[MAX_PATH+2];                   
                   int iPosType;
                   memset(&pDlgParam->mru,0,sizeof(pDlgParam->mru));
                   GetDlgItemText(hDlg,IDC_FILEDISK_FILENAMEMOUNT,szFileName,MAX_PATH);
                   MultiByteToWideChar(CP_ACP, 0 /*WC_DEFAULTCHAR */ ,
                                    (LPCSTR) szFileName, -1,
                                    pDlgParam->mru.FileNameMount,sizeof(pDlgParam->mru.FileNameMount)/sizeof(WCHAR));
                   pDlgParam->mru.fFileNameNeedDDKTranslation=TRUE;
                   pDlgParam->mru.fReadOnly = IsDlgButtonChecked(hDlg,IDC_FILEDISK_READONLY) == BST_CHECKED;
                   if (IsDlgButtonChecked(hDlg,IDC_FILEDISK_CHECKLIMITSIZE) == BST_CHECKED)
                   {
                       DWORD dwMulFactor = 1;
                       BOOL fTranslated=FALSE;

                       if (IsDlgButtonChecked(hDlg,IDC_FILEDISK_LIMITSIZE_RADIO_KBYTES) == BST_CHECKED)
                           dwMulFactor = 1024;
                       if (IsDlgButtonChecked(hDlg,IDC_FILEDISK_LIMITSIZE_RADIO_MBYTES) == BST_CHECKED)
                           dwMulFactor = 1024*1024;
                       if (IsDlgButtonChecked(hDlg,IDC_FILEDISK_LIMITSIZE_RADIO_GBYTES) == BST_CHECKED)
                           dwMulFactor = 1024*1024*1024;
                       pDlgParam->mru.LimitImageSize.HighPart = 0;
                       pDlgParam->mru.LimitImageSize.LowPart = GetDlgItemInt(hDlg,IDC_FILEDISK_EDITLIMITSIZE,&fTranslated,FALSE);

                       #ifndef WINIMAGE_EXE
                       pDlgParam->mru.LimitImageSize.QuadPart *= dwMulFactor;
                       #else
                       Multiply64LH(pDlgParam->mru.LimitImageSize.LowPart,pDlgParam->mru.LimitImageSize.HighPart,dwMulFactor,0);
                       #endif
                   }
                   pDlgParam->cDriveLetter = (char)ComboBox_GetItemData(hCtlComboDrive,ComboBox_GetCurSel(hCtlComboDrive));

                   iPosType=(int)ComboBox_GetItemData(hCtlComboFileType,ComboBox_GetCurSel(hCtlComboFileType));
                   switch (iPosType)
                   {
                   case 0 :
                       pDlgParam->mru.MountType = MOUNT_TYPE_ISO;
                       break;

                   case 1 :
                       pDlgParam->mru.MountType = MOUNT_TYPE_BIN;
                       break;
                   case 2 :
                       pDlgParam->mru.MountType = MOUNT_TYPE_DISKIMAGE;
                       break;
                   }

               }

               if ((wId == IDOK) || (wId == IDCANCEL))
               {
                   EndDialog(hDlg, (wId == IDOK));
                   return (TRUE);
               }
           }
           break;

    }
    return FALSE;    
}


BOOL DoDialogMountNewImage(HWND hWnd)
{
    BOOL fRet;
    DWORD dwErr=0;
    DLGMOUNTNEWIMAGEPARAM DlgParam;
    DLGMOUNTNEWIMAGEPROCANDPARAM DlgProcAndParam(&DlgParam);
    memset(&DlgParam.mru,0,sizeof(DlgParam.mru));
    fRet = (BOOL)DialogBoxParam(GetLingResHinst(),
                                "IDD_MOUNTNEWIMAGE", //MAKEINTRESOURCE(IDD_MOUNTNEWIMAGE),
                                hWnd,
                                (DLGPROC)CBDlgProcAndParamDlgProc,
                                (LPARAM)(&DlgProcAndParam));
    if (fRet)
    {
        fRet=DoMount(DlgParam.cDriveLetter,&DlgParam.mru,dwErr);

        if (!fRet)
        {
            TCHAR szErrMsg[(MAX_PATH+2)*2];
            LoadInternatString(IDS_ERRORMOUNTING,szErrMsg,MAX_PATH);
            if (dwErr!=0)
            {
              lstrcat(szErrMsg,"\n");
              GetWin32ErrorMessage(dwErr,szErrMsg,MAX_PATH,TRUE);
            }
            MessageBox(hWnd,szErrMsg,NULL,MB_OK|MB_ICONERROR);
        }

    }
    return fRet;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifdef WINIMAGE_EXE

typedef struct
{
    const MOUNT_REQUEST_DETAIL* pMrd;
    char cDriveLetter;
    UINT uiAddText;
} DLGMOUNTNEWIMAGEINFOFILLEDPARAM;

class DLGMOUNTNEWIMAGEINFOFILLEDPROCANDPARAM:public DLGPROCANDPARAM
{
public:
    DLGMOUNTNEWIMAGEINFOFILLEDPROCANDPARAM(DLGMOUNTNEWIMAGEINFOFILLEDPARAM* pDlgParamSet)
      { pDlgParam = pDlgParamSet; } ;

    ~DLGMOUNTNEWIMAGEINFOFILLEDPROCANDPARAM() { };
    BOOL DlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam);
private:
    DLGMOUNTNEWIMAGEINFOFILLEDPARAM* pDlgParam;
} ;


BOOL DLGMOUNTNEWIMAGEINFOFILLEDPROCANDPARAM::DlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
    switch(message)
    {
    case WM_INITDIALOG:
        {
            TCHAR szTxt[(MAX_PATH*2)+8];
            UINT uiType;
            
            GetDisplayableFileName(pDlgParam->pMrd->FileNameMount,szTxt,MAX_PATH);
            SetDlgItemText(hDlg,IDC_FILEDISK_FILENAMEMOUNT,szTxt);
            InitListOfDrive(GetDlgItem(hDlg,IDC_FILEDISK_COMBODRIVELETTER));
            szTxt[0]=0;
            if (!(pDlgParam->pMrd->fCdRom))
                uiType=IDS_MOUNTTYPEFILE_DISK;
            else
                if ((pDlgParam->pMrd->ShiftImage.QuadPart==0) &&
                    (pDlgParam->pMrd->ShiftSector==0))
                    uiType = IDS_MOUNTTYPEFILE_ISO;
                else
                    uiType = IDS_MOUNTTYPEFILE_BIN;
            LoadInternatString(uiType,szTxt,MAX_PATH);
            SetDlgItemText(hDlg,IDC_FILEDISK_COMBOFILETYPE,szTxt);

            if (pDlgParam->uiAddText!=0)
            {
                LoadInternatString(pDlgParam->uiAddText,szTxt,MAX_PATH*2);
                SetDlgItemText(hDlg,IDC_FILEDISK_MOUNTCURRENTADDINFO,szTxt);
            }

            //InitListOfType(GetDlgItem(hDlg,IDC_FILEDISK_COMBOFILETYPE));
            //InitLimitSizeCtlFromCheck(hDlg);
            break;
        }

     case WM_COMMAND:
           {
               WORD wId = GET_WM_COMMAND_ID(wParam,lParam);
               HWND hCtlComboFileType=GetDlgItem(hDlg,IDC_FILEDISK_COMBOFILETYPE);
               HWND hCtlComboDrive = GetDlgItem(hDlg,IDC_FILEDISK_COMBODRIVELETTER);



               if (wId == IDC_GETHELP)
               {

#ifdef WINIMAGE_EXE
                   WinHelpApp(GetParent(hDlg),HELP_CONTEXT,HELPID_MOUNTIMAGE,"::/mountimage.html");
#endif

                   /*
                   DoHelpContents(hDlg,//*pADDCONTENTDFSDLGParam->pGuiItem,
                                  "::/Ordering_SmartVersion.htm");
                                  */
                   return TRUE;
               }

               if (wId == IDOK)
               {

                   pDlgParam->cDriveLetter = (char)ComboBox_GetItemData(hCtlComboDrive,ComboBox_GetCurSel(hCtlComboDrive));


               }

               if ((wId == IDOK) || (wId == IDCANCEL))
               {
                   EndDialog(hDlg, (wId == IDOK));
                   return (TRUE);
               }
           }
           break;

    }
    return FALSE;    
}



BOOL DoDialogMountNewImageInfoFilled(HWND hWnd,const MOUNT_REQUEST_DETAIL* pMrd,
                                     BOOL fClosingIfAccept,LPBOOL lpfCloseDone,PDISK pDiskToClose)
{
    BOOL fRet;
    DLGMOUNTNEWIMAGEINFOFILLEDPARAM DlgParam;
    DLGMOUNTNEWIMAGEINFOFILLEDPROCANDPARAM DlgProcAndParam(&DlgParam);
    
    DlgParam.pMrd=pMrd;
    DlgParam.uiAddText = fClosingIfAccept ? IDS_FILEDISK_MOUNTCURRENTADDINFONEEDCLOSE : 0;
    if (lpfCloseDone!=NULL)
        *lpfCloseDone=FALSE;

    fRet = (BOOL)DialogBoxParam(GetLingResHinst(),
                                "IDD_MOUNTCURRENTIMAGE",
                                hWnd,
                                (DLGPROC)CBDlgProcAndParamDlgProc,
                                (LPARAM)(&DlgProcAndParam));
    if (fRet)
    {
        DWORD dwErr=0;
        if (fClosingIfAccept && (pDiskToClose!=NULL))
        {
            pDiskToClose->ClearDisk();
            delete(pDiskToClose);
            if (lpfCloseDone!=NULL)
                *lpfCloseDone=TRUE;
        }

        fRet=DoMountDetails(DlgParam.cDriveLetter,DlgParam.pMrd,dwErr);
        if (!fRet)
        {
            TCHAR szErrMsg[(MAX_PATH+2)*2];
            LoadInternatString(IDS_ERRORMOUNTING,szErrMsg,MAX_PATH);
            if (dwErr!=0)
            {
              lstrcat(szErrMsg,"\n");
              GetWin32ErrorMessage(dwErr,szErrMsg,MAX_PATH,TRUE);
            }
            MessageBox(hWnd,szErrMsg,NULL,MB_OK|MB_ICONERROR);
        }
    }
    return fRet;
}
#endif
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifndef WINIMAGE_EXE
typedef struct
{
} DLGABOUTPARAM;

class DLGABOUTPROCANDPARAM:public DLGPROCANDPARAM
{
public:
    DLGABOUTPROCANDPARAM(DLGABOUTPARAM* pDlgParamSet)
      { pDlgParam = pDlgParamSet; } ;

    ~DLGABOUTPROCANDPARAM() { };
    BOOL DlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam);
private:
    DLGABOUTPARAM* pDlgParam;
} ;


BOOL DLGABOUTPROCANDPARAM::DlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
    switch(message)
    {
    case WM_INITDIALOG:
        {
            QUERY_FILE_DISK_VERSION qfdv;
            memset(&qfdv,0,sizeof(qfdv));
            if (GetFileDiskDriverInfo(&qfdv))
            {
                TCHAR szNum[256];
                wsprintf(szNum,"%u.%u %ws",qfdv.MajorVersion,qfdv.MinorVersion,qfdv.InfoString);
                SetDlgItemText(hDlg,IDC_INFOABOUT,szNum);
            }
        }
        break;

     case WM_COMMAND:
           {
               WORD wId = GET_WM_COMMAND_ID(wParam,lParam);

               if (wId == IDC_GETHELP)
               {

#ifdef WINIMAGE_EXE
                   WinHelpApp(GetParent(hDlg),HELP_CONTEXT,HELPID_MOUNTIMAGE,"::/mountimage.html");
#endif

                   /*
                   DoHelpContents(hDlg,//*pADDCONTENTDFSDLGParam->pGuiItem,
                                  "::/Ordering_SmartVersion.htm");
                                  */
                   return TRUE;
               }

               if (wId == IDOK)
               {
               }

               if ((wId == IDOK) || (wId == IDCANCEL))
               {
                   EndDialog(hDlg, (wId == IDOK));
                   return (TRUE);
               }
           }
           break;

    }
    return FALSE;    
}

BOOL DoDialogAbout(HWND hWnd)
{
    BOOL fRet;
    DLGABOUTPARAM DlgParam;
    DLGABOUTPROCANDPARAM DlgProcAndParam(&DlgParam);
    
    fRet = (BOOL)DialogBoxParam(ghRes,
                                MAKEINTRESOURCE(IDD_ABOUT),
                                hWnd,
                                (DLGPROC)CBDlgProcAndParamDlgProc,
                                (LPARAM)(&DlgProcAndParam));
    return fRet;
}
#endif
