
// fdtools.cpp
#include <stdlib.h>
#include <windows.h>
#include <winioctl.h>
#include <windowsx.h>
#include "filedisk.h"
#include "fd_tools.h"



#ifndef INVALID_SET_FILE_POINTER
#define INVALID_SET_FILE_POINTER ((DWORD)0xFFFFFFFFL)
#endif

BOOL IsDriveAssigned(DWORD dwDrive)
{
    TCHAR VolumeName[8] ;
    TCHAR szDosDevice[MAX_PATH+0x10];

    lstrcpy(VolumeName,"\\\\.\\ :");
    VolumeName[4] = (TCHAR)(dwDrive+'a');


    szDosDevice[0]=0;
    if (QueryDosDevice(&VolumeName[4],szDosDevice,MAX_PATH)==0)
        return GetLastError() == ERROR_INSUFFICIENT_BUFFER;
    if (szDosDevice[0]==0)
        return FALSE;
    return TRUE;
}

BOOL GetMountInfo(DWORD dwDrive,MOUNT_INFORMATION* pmi)
{
    TCHAR                   VolumeName[8] ;
    HANDLE                  Device;
    POPEN_FILE_INFORMATION  OpenFileInformation;
    POPEN_FILE_INFORMATION_EX  OpenFileInformationEx;
    DWORD                      BytesReturned;
    BOOL                       fRet = FALSE;



/*

    TCHAR szAll[2048*8];
    memset(szAll,0,sizeof(szAll));
    DWORD dwr=QueryDosDevice(NULL,szAll,sizeof(szAll)/sizeof(TCHAR));
    DWORD dwe=GetLastError();
*/





    lstrcpy(VolumeName,"\\\\.\\ :");
    VolumeName[4] = (TCHAR)(dwDrive+'a');

    {
        TCHAR szDosDevice[MAX_PATH+0x10];
        szDosDevice[0]=0;
        QueryDosDevice(&VolumeName[4],szDosDevice,MAX_PATH);
        if (memcmp(szDosDevice,"\\Device\\FileDisk\\",17)!=0)
            return FALSE;
    }

    Device = CreateFile(
        VolumeName,
        GENERIC_READ,
        FILE_SHARE_READ | FILE_SHARE_WRITE,
        NULL,
        OPEN_EXISTING,
        FILE_FLAG_NO_BUFFERING,
        NULL
        );

    if ((Device == INVALID_HANDLE_VALUE) || (Device == NULL))
    {
        return FALSE;
    }

    OpenFileInformationEx = (POPEN_FILE_INFORMATION_EX)malloc(sizeof(OPEN_FILE_INFORMATION_EX) + MAX_PATH);
    if (OpenFileInformationEx == NULL)
    {
        CloseHandle(Device);
        return FALSE;
    }

    OpenFileInformation = (POPEN_FILE_INFORMATION)malloc(sizeof(OPEN_FILE_INFORMATION) + MAX_PATH);
    if (OpenFileInformation == NULL)
    {
        free(OpenFileInformationEx);
        CloseHandle(Device);
        return FALSE;
    }

/*
    if (DeviceIoControl(
        Device,
        IOCTL_FILE_DISK_QUERY_FILE_EX,
        NULL,
        0,
        OpenFileInformationEx,
        sizeof(OPEN_FILE_INFORMATION_EX) + MAX_PATH,
        &BytesReturned,
        NULL
        ))
    {
        fRet = TRUE;
        memset(pmi,0,sizeof(MOUNT_INFORMATION));
        pmi->fReadOnly = OpenFileInformationEx->ReadOnly;
        pmi->SizeMountedData = OpenFileInformationEx->LimitImageSize;
        if (pmi->SizeMountedData.QuadPart==0)
            pmi->SizeMountedData = OpenFileInformationEx->FileSize;
        memcpy(pmi->FileNameMount,OpenFileInformationEx->FileName,min(MAX_PATH,OpenFileInformationEx->FileNameLength)*sizeof(WCHAR));
        *((pmi->FileNameMount)+min(MAX_PATH,OpenFileInformationEx->FileNameLength))=0;
    }
*/
    if (!fRet)
        if (DeviceIoControl(
            Device,
            IOCTL_FILE_DISK_QUERY_FILE,
            NULL,
            0,
            OpenFileInformation,
            sizeof(OPEN_FILE_INFORMATION) + MAX_PATH,
            &BytesReturned,
            NULL
            ))
    {
        fRet = TRUE;
        memset(pmi,0,sizeof(MOUNT_INFORMATION));
        pmi->fReadOnly = OpenFileInformation->ReadOnly;
        pmi->SizeMountedData = OpenFileInformation->FileSize;

        MultiByteToWideChar(CP_ACP, 0 /*WC_DEFAULTCHAR */ ,
                   (LPCSTR) OpenFileInformation->FileName,  OpenFileInformation->FileNameLength,
                    pmi->FileNameMount,MAX_PATH);
    }

    free(OpenFileInformation);
    free(OpenFileInformationEx);
    CloseHandle(Device);
    return fRet;
}


BOOL FileDiskUmount(char DriveLetter,DWORD &dwErr)
{
    TCHAR   VolumeName[8] = "\\\\.\\ :";
    HANDLE  Device;
    DWORD   BytesReturned;

    lstrcpy(VolumeName,"\\\\.\\ :");

    VolumeName[4] = DriveLetter+'a';
    dwErr=0;

    Device = CreateFile(
        VolumeName,
        GENERIC_READ | GENERIC_WRITE,
        FILE_SHARE_READ | FILE_SHARE_WRITE,
        NULL,
        OPEN_EXISTING,
        FILE_FLAG_NO_BUFFERING,
        NULL
        );

    if (Device == INVALID_HANDLE_VALUE)
    {
        dwErr=GetLastError();
        return FALSE;
    }

    if (!DeviceIoControl(
        Device,
        FSCTL_LOCK_VOLUME,
        NULL,
        0,
        NULL,
        0,
        &BytesReturned,
        NULL
        ))
    {
        dwErr=GetLastError();
        CloseHandle(Device);
        return FALSE;
    }

    if (!DeviceIoControl(
        Device,
        IOCTL_FILE_DISK_CLOSE_FILE,
        NULL,
        0,
        NULL,
        0,
        &BytesReturned,
        NULL
        ))
    {
        dwErr=GetLastError();
        CloseHandle(Device);
        return FALSE;
    }

    if (!DeviceIoControl(
        Device,
        FSCTL_DISMOUNT_VOLUME,
        NULL,
        0,
        NULL,
        0,
        &BytesReturned,
        NULL
        ))
    {
        dwErr=GetLastError();
        CloseHandle(Device);
        return FALSE;
    }

    if (!DeviceIoControl(
        Device,
        FSCTL_UNLOCK_VOLUME,
        NULL,
        0,
        NULL,
        0,
        &BytesReturned,
        NULL
        ))
    {
        dwErr=GetLastError();
        CloseHandle(Device);
        return FALSE;
    }

    CloseHandle(Device);

    if (!DefineDosDevice(
        DDD_REMOVE_DEFINITION,
        &VolumeName[4],
        NULL
        ))
    {
        dwErr=GetLastError();
        return FALSE;
    }

    return TRUE;
}


//////////////////////////////////

#define MAX_FDUNIT (0x20)
typedef struct
{
    BOOL fCdDeviceUsed[MAX_FDUNIT];
    BOOL fDiskImageDeviceUsed[MAX_FDUNIT];
} FILEDISK_DEVICE_USED;

BOOL FillFileDiskDeviceUsed(FILEDISK_DEVICE_USED *pFdu)
{
    DWORD i;
    /*
    TCHAR szAll[2048+8];
    memset(szAll,0,sizeof(szAll));
    QueryDosDevice(NULL,szAll,sizeof(szAll)/sizeof(TCHAR));
*/
    for (i=0;i<MAX_FDUNIT;i++)
        pFdu->fCdDeviceUsed[i]=pFdu->fDiskImageDeviceUsed[i]=FALSE;

    for (i=0;i<26;i++)
    {
        TCHAR szDosDevice[MAX_PATH+0x10];
        TCHAR szDevName[8];
        szDosDevice[0]=0;
        wsprintf(szDevName,"%c:",i+'a');
        QueryDosDevice(szDevName,szDosDevice,MAX_PATH);
        if (memcmp(szDosDevice,"\\Device\\FileDisk\\FileDiskCd",17+10)==0)
        {
            int iNbr = atoi(szDosDevice + 17 + 10);
            if (iNbr < MAX_FDUNIT)
                pFdu->fCdDeviceUsed[iNbr]=TRUE;
        }
        else
        if (memcmp(szDosDevice,"\\Device\\FileDisk\\FileDisk",17+8)==0)
        {
            int iNbr = atoi(szDosDevice + 17 + 8);
            if (iNbr < MAX_FDUNIT)
                pFdu->fDiskImageDeviceUsed[iNbr]=TRUE;
        }
    }
    return TRUE;
}


BOOL
FileDiskMountEx(
    int                     DeviceNumber,
    POPEN_FILE_INFORMATION_EX  OpenFileInformation,
    char                    DriveLetter,
    BOOL                    CdImage,
    DWORD                   &dwErrWin32)
{
    char    VolumeName[] = "\\\\.\\ :";
    char    DeviceName[255];
    HANDLE  Device;
    DWORD   BytesReturned;

    VolumeName[4] = DriveLetter;
    dwErrWin32 = 0;

    Device = CreateFile(
        VolumeName,
        GENERIC_READ | GENERIC_WRITE,
        FILE_SHARE_READ | FILE_SHARE_WRITE,
        NULL,
        OPEN_EXISTING,
        FILE_FLAG_NO_BUFFERING,
        NULL
        );

    if (Device != INVALID_HANDLE_VALUE)
    {
        SetLastError(ERROR_BUSY);
        //PrintLastError(&VolumeName[4]);
        dwErrWin32 = ERROR_BUSY;
        return FALSE;
    }

    if (CdImage)
    {
        wsprintf(DeviceName, DEVICE_NAME_PREFIX "Cd" "%u", DeviceNumber);
    }
    else
    {
        wsprintf(DeviceName, DEVICE_NAME_PREFIX "%u", DeviceNumber);
    }

    if (!DefineDosDevice(
        DDD_RAW_TARGET_PATH,
        &VolumeName[4],
        DeviceName
        ))
    {
        //PrintLastError(&VolumeName[4]);
        dwErrWin32 = GetLastError();
        return FALSE;
    }

    Device = CreateFile(
        VolumeName,
        GENERIC_READ | GENERIC_WRITE,
        FILE_SHARE_READ | FILE_SHARE_WRITE,
        NULL,
        OPEN_EXISTING,
        FILE_FLAG_NO_BUFFERING,
        NULL
        );

    if ((Device == INVALID_HANDLE_VALUE) || (Device==NULL))
    {
        //PrintLastError(&VolumeName[4]);
        dwErrWin32 = GetLastError();
        DefineDosDevice(DDD_REMOVE_DEFINITION, &VolumeName[4], NULL);
        return FALSE;
    }

    if (!DeviceIoControl(
        Device,
        IOCTL_FILE_DISK_OPEN_FILE_EX,
        OpenFileInformation,
        sizeof(OPEN_FILE_INFORMATION_EX) + ((OpenFileInformation->FileNameLength - 1)*sizeof(WCHAR)),
        NULL,
        0,
        &BytesReturned,
        NULL
        ))
    {
        //PrintLastError("FileDisk:");
        dwErrWin32 = GetLastError();
        CloseHandle(Device);
        DefineDosDevice(DDD_REMOVE_DEFINITION, &VolumeName[4], NULL);
        return FALSE;
    }

    CloseHandle(Device);
    dwErrWin32=NO_ERROR;
    return TRUE;
}


BOOL
FileDiskMount(
    int                     DeviceNumber,
    POPEN_FILE_INFORMATION  OpenFileInformation,
    char                    DriveLetter,
    BOOL                    CdImage,
    DWORD                   &dwErrWin32)
{
    char    VolumeName[] = "\\\\.\\ :";
    char    DeviceName[255];
    HANDLE  Device;
    DWORD   BytesReturned;

    dwErrWin32 = 0;
    VolumeName[4] = DriveLetter;

    Device = CreateFile(
        VolumeName,
        GENERIC_READ | GENERIC_WRITE,
        FILE_SHARE_READ | FILE_SHARE_WRITE,
        NULL,
        OPEN_EXISTING,
        FILE_FLAG_NO_BUFFERING,
        NULL
        );

    if (Device != INVALID_HANDLE_VALUE)
    {
        SetLastError(ERROR_BUSY);
        //PrintLastError(&VolumeName[4]);
        dwErrWin32 = ERROR_BUSY;
        return FALSE;
    }

    if (CdImage)
    {
        wsprintf(DeviceName, DEVICE_NAME_PREFIX "Cd" "%u", DeviceNumber);
    }
    else
    {
        wsprintf(DeviceName, DEVICE_NAME_PREFIX "%u", DeviceNumber);
    }

    if (!DefineDosDevice(
        DDD_RAW_TARGET_PATH,
        &VolumeName[4],
        DeviceName
        ))
    {
        //PrintLastError(&VolumeName[4]);
        dwErrWin32 = GetLastError();
        return FALSE;
    }

    Device = CreateFile(
        VolumeName,
        GENERIC_READ | GENERIC_WRITE,
        FILE_SHARE_READ | FILE_SHARE_WRITE,
        NULL,
        OPEN_EXISTING,
        FILE_FLAG_NO_BUFFERING,
        NULL
        );

    if ((Device == INVALID_HANDLE_VALUE) || (Device==NULL))
    {
        dwErrWin32 = GetLastError();
        //PrintLastError(&VolumeName[4]);
        DefineDosDevice(DDD_REMOVE_DEFINITION, &VolumeName[4], NULL);
        return FALSE;
    }

    if (!DeviceIoControl(
        Device,
        IOCTL_FILE_DISK_OPEN_FILE,
        OpenFileInformation,
        sizeof(OPEN_FILE_INFORMATION) + ((OpenFileInformation->FileNameLength - 1)*sizeof(UCHAR)),
        NULL,
        0,
        &BytesReturned,
        NULL
        ))
    {
        dwErrWin32 = GetLastError();
        //PrintLastError("FileDisk:");
        CloseHandle(Device);
        DefineDosDevice(DDD_REMOVE_DEFINITION, &VolumeName[4], NULL);
        return FALSE;
    }

    CloseHandle(Device);

    dwErrWin32=NO_ERROR;
    return TRUE;
}


typedef struct
{
    OPEN_FILE_INFORMATION OpenFileInformation;
    UCHAR spaceName[MAX_PATH+0x10];
} OFI_WITHSPACENAME;

typedef struct
{
    OPEN_FILE_INFORMATION_EX OpenFileInformationEx;
    WCHAR spaceName[MAX_PATH+0x10];
} OFI_WITHSPACENAME_EX;

BOOL DoMountDetails(char cDriveLetter,const MOUNT_REQUEST_DETAIL* pMrd,DWORD &dwErrWin32)
{
    BOOL fCompatibleOpenFileInformation;
    OFI_WITHSPACENAME ofi;
    OFI_WITHSPACENAME_EX ofiEx;
    FILEDISK_DEVICE_USED fdu;
    BOOL fReadOnly = (pMrd->fReadOnly) || (pMrd->fCdRom);
    int iFreeDevice;

    dwErrWin32=0;

    memset(&ofi,0,sizeof(ofi));
    memset(&ofiEx,0,sizeof(ofiEx));

    lstrcpyW(ofiEx.OpenFileInformationEx.FileName,pMrd->FileNameMount);
    ofiEx.OpenFileInformationEx.FileNameLength = lstrlenW(ofiEx.OpenFileInformationEx.FileName);

    ofiEx.OpenFileInformationEx.LimitImageSize = pMrd->LimitImageSize;
    ofiEx.OpenFileInformationEx.ShiftImage = pMrd->ShiftImage;
    ofiEx.OpenFileInformationEx.SizeSector = pMrd->SizeSector;
    ofiEx.OpenFileInformationEx.ShiftSector = pMrd->ShiftSector;
    ofiEx.OpenFileInformationEx.ExtraFlags = pMrd->ExtraFlags;
    ofiEx.OpenFileInformationEx.ReadOnly = fReadOnly;
    ofiEx.OpenFileInformationEx.FileSize = pMrd->FileSize;

    fCompatibleOpenFileInformation = ((pMrd->ShiftImage.QuadPart==0) && (pMrd->ShiftSector==0));
    if (fCompatibleOpenFileInformation)
    {
        int iRet;
        ofi.OpenFileInformation.ReadOnly = fReadOnly;
        ofi.OpenFileInformation.FileSize = pMrd->FileSize;

        iRet = WideCharToMultiByte(CP_ACP, 0 /*WC_DEFAULTCHAR */ ,
                pMrd->FileNameMount,-1,
                (LPSTR)ofi.OpenFileInformation.FileName,MAX_PATH,
                NULL,NULL);
        fCompatibleOpenFileInformation = iRet>0;
        ofi.OpenFileInformation.FileNameLength=iRet;
    }

    if (FillFileDiskDeviceUsed(&fdu))
    {
        DWORD i;
        BOOL fFreeDeviceFound=FALSE;
        for (i=0;i<MAX_FDUNIT;i++)
            {
                BOOL fDisposable;
                if (pMrd->fCdRom)
                    fDisposable = !fdu.fCdDeviceUsed[i];
                else
                    fDisposable = !fdu.fDiskImageDeviceUsed[i];

                if (fDisposable)
                {
                    fFreeDeviceFound = TRUE;
                    iFreeDevice = i;
                    break;
                }
            }
        if (!fFreeDeviceFound)
        {
            dwErrWin32=ERROR_INVALID_DRIVE;
            return FALSE;
        }
    }

    if (FileDiskMountEx(iFreeDevice,&ofiEx.OpenFileInformationEx,cDriveLetter+'a',pMrd->fCdRom,dwErrWin32))
    {
        //MessageBox(0,"ok with ex","ex",0);
        return TRUE;
    }

    if (FileDiskMount(iFreeDevice,&ofi.OpenFileInformation,cDriveLetter+'a',pMrd->fCdRom,dwErrWin32))
    {
        //MessageBox(0,"ok with std","std",0);
        return TRUE;
    }

    return FALSE;
}


BOOL TryBinValue(HANDLE hFileBin,ULONG ShiftImage,ULONG ShiftSector)
{
    char szBuffer[0x10];
    DWORD dwRead=0;

    if (SetFilePointer(hFileBin,ShiftImage+((0x800+ShiftSector)*0x10),NULL,FILE_BEGIN)==INVALID_SET_FILE_POINTER)
        return FALSE;
    if (!ReadFile(hFileBin,szBuffer,0x10,&dwRead,NULL))
        return FALSE;
    if (dwRead != 0x10)
        return FALSE;
    if (memcmp(szBuffer+1,"CD001",5)!=0)
        return FALSE;

    if (SetFilePointer(hFileBin,ShiftImage+((0x800+ShiftSector)*0x11),NULL,FILE_BEGIN)==INVALID_SET_FILE_POINTER)
        return FALSE;
    if (!ReadFile(hFileBin,szBuffer,0x10,&dwRead,NULL))
        return FALSE;
    if (dwRead != 0x10)
        return FALSE;
    if (memcmp(szBuffer+1,"CD001",5)!=0)
        return FALSE;

    return TRUE;
}

BOOL oldGetBinGeometry(LPCWSTR FileName,ULONG *pShiftSector,ULONG *pShiftImage)
{
    HANDLE hFileBin;
    BOOL fRet=FALSE;
    hFileBin=CreateFileW(FileName,GENERIC_READ,
                               FILE_SHARE_READ,NULL,OPEN_EXISTING,
                               FILE_FLAG_RANDOM_ACCESS,NULL);
    if ((hFileBin==NULL) || (hFileBin==INVALID_HANDLE_VALUE))
        return FALSE;

    *pShiftImage = 0x8a;
    *pShiftSector = 0;
    fRet = TryBinValue(hFileBin,*pShiftImage,*pShiftSector);

    if (!fRet)
    {
        *pShiftImage = 0x8a;
        *pShiftSector = 0x0;
        fRet = TryBinValue(hFileBin,*pShiftImage,*pShiftSector);
    }

    if (!fRet)
    {
        *pShiftImage = 0x92;
        *pShiftSector = 0x08;
        fRet = TryBinValue(hFileBin,*pShiftImage,*pShiftSector);
    }

    if (!fRet)
    {
        *pShiftImage = 0x10;
        *pShiftSector = 0x130;
        fRet = TryBinValue(hFileBin,*pShiftImage,*pShiftSector);
    }


    if (!fRet)
    {
        *pShiftImage = 0x18;
        *pShiftSector = 0x130;
        fRet = TryBinValue(hFileBin,*pShiftImage,*pShiftSector);
    }

    if (!fRet)
    {
        *pShiftImage = 0x08;
        *pShiftSector = 0x11c;
        fRet = TryBinValue(hFileBin,*pShiftImage,*pShiftSector);
    }

    if (!fRet)
    {
        *pShiftImage = 0x10;
        *pShiftSector = 0x120;
        fRet = TryBinValue(hFileBin,*pShiftImage,*pShiftSector);
    }

    if (!fRet)
    {
        *pShiftImage = 0x08;
        *pShiftSector = 0x120;
        fRet = TryBinValue(hFileBin,*pShiftImage,*pShiftSector);
    }

    CloseHandle(hFileBin);
    return fRet;
}

#define AroundLower(dwValue,dwModulo) ((((DWORD)(dwValue)) / ((DWORD)(dwModulo))) * (dwModulo))

BOOL GetBinGeometry(LPCWSTR FileName,ULONG *pShiftSector,ULONG *pShiftImage)
{
    HANDLE hFileBin;
    BOOL fRet=FALSE;
    HANDLE hFileMap;
    PCHAR pchFileBase ;
    DWORD dwSizeLow,dwSizeHigh,dwSizeMap;
    SYSTEM_INFO si;
    hFileBin=CreateFileW(FileName,GENERIC_READ,
                               FILE_SHARE_READ,NULL,OPEN_EXISTING,
                               FILE_FLAG_RANDOM_ACCESS,NULL);
    if ((hFileBin==NULL) || (hFileBin==INVALID_HANDLE_VALUE))
        return FALSE;

    dwSizeMap = 1024 * 1024;
    dwSizeHigh=0;
    dwSizeLow=GetFileSize(hFileBin,&dwSizeHigh);
    if ((dwSizeMap>dwSizeLow) && (dwSizeHigh==0))
        dwSizeMap = dwSizeLow;
    GetSystemInfo(&si);
    dwSizeMap = AroundLower(dwSizeMap,si.dwPageSize);

    hFileMap = CreateFileMapping(hFileBin, NULL, PAGE_READONLY, 0, dwSizeMap, NULL);
    if(!hFileMap)
    {
        CloseHandle(hFileBin);
        return FALSE;
    }
    pchFileBase = (PCHAR)MapViewOfFile(hFileMap, FILE_MAP_READ, 0, 0, dwSizeMap);
    if (pchFileBase!=NULL)
    {
          DWORD i,j;
          DWORD dwLimitTst=dwSizeMap-0x1000;
          LPBYTE lpBuf = (LPBYTE)pchFileBase;


          if (dwSizeMap>0x9000)
              for (i=0x8000;(i<dwLimitTst);i++)
              {
#define TEST_ONE_LPBUF1 { if ((*(lpBuf+i)!=1)) i++; }
#define TEST_ONE_LPBUF4 TEST_ONE_LPBUF1; TEST_ONE_LPBUF1; TEST_ONE_LPBUF1; TEST_ONE_LPBUF1;
                  TEST_ONE_LPBUF4;
                  TEST_ONE_LPBUF4;

                  if ((*(lpBuf+i)==1) && (*(lpBuf+i+1)=='C'))
                  {
                      if (memcmp(lpBuf+i+1,"CD001",5)==0)
                      {
                          for (j=0;j<0x300;j++)
                              if (memcmp(lpBuf+i+1+0x800+j,"CD001",5)==0)
                              {
                                  *pShiftSector=j;
                                  *pShiftImage = i - ((j+0x800)*0x10);
                                  fRet=TRUE;

                                  break;
                              }
                      }
                      if (fRet)
                          break;
                  }
              }
          //


        UnmapViewOfFile(pchFileBase);
    }
    CloseHandle(hFileMap);
    CloseHandle(hFileBin);
    return fRet;
}

BOOL BuildFileNameMountDDK(LPWSTR lpDest,DWORD dwNbWCharBuf,LPCTSTR lpszFn)
{
    BOOL fRet=FALSE;
    DWORD dwNbCharAllocated=lstrlen(lpszFn)+0x10;
    LPWSTR lpwfn =(LPWSTR)GlobalAllocPtr(GHND,(dwNbCharAllocated+2)*sizeof(WCHAR));
    if (lpwfn == NULL)
        return FALSE;

    if (MultiByteToWideChar(CP_ACP, 0 /*WC_DEFAULTCHAR */ ,
            (LPCSTR) lpszFn,  -1,
            lpwfn,dwNbCharAllocated) > 0)
    {
        if ((*lpwfn) == '\\')
        {
            if ((*(lpwfn+1)) == '\\')
                // \\server\share\path\filedisk.img
            {
                lstrcpyW(lpDest, L"\\??\\UNC");
                DWORD iPos = lstrlenW(lpDest);
                fRet=dwNbWCharBuf>iPos;
                if (fRet)
                {
                    lstrcpynW(lpDest+iPos, lpwfn+1,dwNbWCharBuf-iPos);
                }
            }
            else
                // \Device\Harddisk0\Partition1\path\filedisk.img
            {
                lstrcpynW(lpDest, lpwfn,dwNbWCharBuf);
                fRet=TRUE;
            }
        }
        else
            // c:\path\filedisk.img
        {
            DWORD iPos;
            LPWSTR lpFilePart;

            lstrcpyW(lpDest, L"\\??\\");
            iPos = lstrlenW(lpDest);
            
            fRet= dwNbWCharBuf>iPos;
            if (fRet)
                GetFullPathNameW(lpwfn,dwNbWCharBuf-iPos,lpDest+iPos,&lpFilePart);
        }
    }
    
    return fRet;
}

BOOL DoMount(char DriveLetter,const MOUNT_REQUEST_USER* pMru,DWORD &dwErrWin32)
{
    MOUNT_REQUEST_DETAIL mrd;
    memset(&mrd,0,sizeof(mrd));

    if (!pMru->fFileNameNeedDDKTranslation)
    {
        lstrcpyW(mrd.FileNameMount,pMru->FileNameMount);
    }
    else
    {

        if (pMru->FileNameMount[0] == '\\')
        {
            if (pMru->FileNameMount[1] == '\\')
                // \\server\share\path\filedisk.img
            {
                lstrcpyW(mrd.FileNameMount, L"\\??\\UNC");
                lstrcatW(mrd.FileNameMount, (pMru->FileNameMount) + 1);
            }
            else
                // \Device\Harddisk0\Partition1\path\filedisk.img
            {
                lstrcpyW(mrd.FileNameMount, (pMru->FileNameMount));
            }
        }
        else
            // c:\path\filedisk.img
        {
            int iPos;
            LPWSTR lpFilePart;

            lstrcpyW(mrd.FileNameMount, L"\\??\\");
            iPos = lstrlenW(mrd.FileNameMount);

            GetFullPathNameW((pMru->FileNameMount),(sizeof(pMru->FileNameMount)/sizeof(WCHAR))-iPos,(mrd.FileNameMount)+iPos,&lpFilePart);
        }

    }

    mrd.FileSize = pMru->FileSize;
    mrd.LimitImageSize=pMru->LimitImageSize;
    mrd.ShiftImage=pMru->LimitImageSize;
    mrd.fReadOnly=pMru->fReadOnly;
    mrd.fCdRom = pMru->MountType != MOUNT_TYPE_DISKIMAGE;

    if (pMru->MountType == MOUNT_TYPE_BIN)
    {
        ULONG ShiftSectorOld=0;
        ULONG ShiftImagelowPartOld=0;
        if (!oldGetBinGeometry(pMru->FileNameMount,&ShiftSectorOld,&ShiftImagelowPartOld))
            return FALSE;

        if (!GetBinGeometry(pMru->FileNameMount,&mrd.ShiftSector,&mrd.ShiftImage.LowPart))
            return FALSE;

        mrd.ShiftImage.HighPart=0;
        mrd.SizeSector=0x800;
    }

    BOOL fRet=DoMountDetails(DriveLetter,&mrd,dwErrWin32);
    return fRet;
}

/**********************************************/

//#include "Winternl.h"


BOOL CheckFileDiskInstalled()
{
    BOOL fRet=FALSE;
    HKEY hCurKey=NULL;

    // exit for Win32s or Win9x
    if ((GetVersion() & 0x80000000) != 0)
        return FALSE ;

    DWORD dwRet = (RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Services\\FileDisk",0,
                          KEY_READ,&hCurKey));
    BOOL fOpenKey = dwRet == ERROR_SUCCESS;
    if (fOpenKey)
    {
        DWORD dw=0;
        DWORD dwType=0;
        DWORD dwDataSize=sizeof(dw);
        if (RegQueryValueEx(hCurKey,"Start",NULL,&dwType,(LPBYTE)&dw,&dwDataSize)==
            ERROR_SUCCESS)
            if ((dwDataSize==sizeof(dw)) &&  (dwType==REG_DWORD))
            {
                fRet=dw>0;
            }
        RegCloseKey(hCurKey);
    }
    return fRet;
}

BOOL GetFileDiskDriverInfo(QUERY_FILE_DISK_VERSION *pqfdv)
{
    BOOL fRet=FALSE;
    //\Device\FileDisk\FileDiskCd0
    HANDLE Device;
    DWORD BytesReturned=0;
    TCHAR VolumeName[MAX_PATH];
    if (!CheckFileDiskInstalled())
        return FALSE;
    lstrcpy(VolumeName,"\\\\.\\Device\\FileDisk\\FileDiskCd0");
    Device = CreateFile(
        VolumeName,
        GENERIC_READ,
        FILE_SHARE_READ/* | FILE_SHARE_WRITE*/,
        NULL,
        OPEN_EXISTING,
        FILE_FLAG_NO_BUFFERING,
        NULL
        ); // NtCreateFile
    DWORD dwErr=GetLastError();
    if ((Device==NULL) || (Device==INVALID_HANDLE_VALUE))
        return FALSE;

    fRet = DeviceIoControl(
            Device,
            IOCTL_FILE_DISK_QUERY_VERSION,
            NULL,
            0,
            pqfdv,
            sizeof(QUERY_FILE_DISK_VERSION),
            &BytesReturned,
            NULL
            );

    CloseHandle(Device);
    return fRet;
}
